package edu.kit.ipd.descartes.adaptation.evaluation.performance.repository;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import edu.kit.ipd.descartes.adaptation.model.AbstractEcoreModelLoader;
import edu.kit.ipd.descartes.ql.models.repository.RepositoryPackage;

public class ObservationRepositoryModelLoader extends AbstractEcoreModelLoader {

    public static final EPackage[] OBSERVATION_REPO_EPACKAGES = new EPackage[] { 
        RepositoryPackage.eINSTANCE
        };

    private static ObservationRepositoryModelLoader instance = null;

    public static ObservationRepositoryModelLoader getInstance() {
        if (instance == null) {
            instance = new ObservationRepositoryModelLoader();
        }
        return instance;
    }
    
    private ObservationRepositoryModelLoader() {
        initializeResourceSet(new ResourceSetImpl());
    }
    
    @Override
    public void initializeResourceSet(ResourceSet resourceSet) {
        setResourceSet(resourceSet);
        
        /* Register the default resource factory -- only needed for stand-alone! */
        getResourceSet().getResourceFactoryRegistry().getExtensionToFactoryMap()
                .put(Resource.Factory.Registry.DEFAULT_EXTENSION, new XMIResourceFactoryImpl());

        /* Register also the packages needed for the DMM meta model */
        for (EPackage ePackage : OBSERVATION_REPO_EPACKAGES) {
            getResourceSet().getResourceFactoryRegistry().getExtensionToFactoryMap().put(ePackage.getNsURI(), ePackage);
        }
    }

}
